﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Mvc;

namespace MvcApp.Controllers
{
    public class HomeController : Controller
    {

        public ActionResult Index()
        {
            return View();
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Index(string Generate)
        {

            using (HttpClient client = new HttpClient())
            {
                client.BaseAddress = new Uri("http://localhost:55499/");
                var result = client.PostAsync("/api/WebAPI", null).Result;
                if (result.IsSuccessStatusCode)
                {
                    byte[] pdfContent = result.Content.ReadAsByteArrayAsync().Result;
                    using (MemoryStream stream = new MemoryStream())
                    {
                        stream.Write(pdfContent, 1, pdfContent.Length - 2);
                        byte[] base64ByteContent = stream.ToArray();
                        string conten = System.Text.Encoding.UTF8.GetString(base64ByteContent);
                        byte[] newPdfBytContent = Convert.FromBase64String(conten);

                        string inputFileFormat = string.Empty;

                        #region CheckIsPDF
                        using (MemoryStream pdfHeaderStream = new MemoryStream())
                            {
                                pdfHeaderStream.Write(newPdfBytContent, 0, 1024);
                                string pdfHeaderContent = System.Text.Encoding.UTF8.GetString(pdfHeaderStream.ToArray());
                                if (pdfHeaderContent.Contains("%PDF-"))
                                {
                                    inputFileFormat = "PDF";
                                }
                            }
                        #endregion
                        if (inputFileFormat==string.Empty)
                        {
                            #region CheckIsHtml
                            Regex tagRegex = new Regex(@"<\s*([^ >]+)[^>]*>.*?<\s*/\s*\1\s*>");
                            string htmlString = System.Text.Encoding.UTF8.GetString(newPdfBytContent);
                            bool isHtmlFile = tagRegex.IsMatch(htmlString);
                            if (isHtmlFile)
                                inputFileFormat = "HTML";
                            #endregion
                        }


                        if (inputFileFormat == string.Empty)
                        {

                            Stream inFileStream = new MemoryStream(newPdfBytContent);


                            BinaryReader reader = new BinaryReader(inFileStream);

                            reader.ReadBytes(16); // Skip the header data.

                            int fileSize = (int)reader.ReadUInt32();

                            int attachmentNameLength = (int)reader.ReadUInt32() * 2;

                            byte[] fileNameBytes = reader.ReadBytes(attachmentNameLength);

                            string value = Encoding.UTF8.GetString(fileNameBytes, 0, fileNameBytes.Length);

                            int excel = value.Contains("xl") ? value.IndexOf("xl") : int.MaxValue;


                            int word = value.Contains("word") ? value.IndexOf("word") : int.MaxValue;


                            int ppt = value.Contains("ppt") ? value.IndexOf("ppt") : int.MaxValue;

                            if (excel < word && excel < ppt)
                                inputFileFormat = "Excel";
                            else if (word < ppt && word < excel)
                                inputFileFormat = "Word";
                            else
                                inputFileFormat = "PowerPoint";
                        }

                        Response.Clear();
                        MemoryStream ms = new MemoryStream(newPdfBytContent);
                        Response.ContentType = "application/pdf";
                        Response.AddHeader("content-disposition", "attachment;filename=Sample" + DateTime.Now.Ticks.ToString() + ".pdf");
                        Response.Buffer = true;
                        ms.WriteTo(Response.OutputStream);
                        Response.End();
                    }
                }
            }
            return View();

        }
    }
}
